#
# Copyright (c) 2021 Josef 'Jeff' Sipek <jeffpc@josefsipek.net>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#

# read in the source file
file(READ "${SRC}" HEXDATA HEX)

# hexdump the data
set(data "")
while("${HEXDATA}" MATCHES ".")
	string(SUBSTRING ${HEXDATA} 0 2 BYTE)
	string(SUBSTRING ${HEXDATA} 2 -1 HEXDATA)
	set(data "${data}0x${BYTE},")
endwhile()

set(out "/* ${DST} - Generated by cmake. Changes will be lost! */\n"
	"#include <jeffpc/types.h>\n"
	"const uint8_t ${SYMBOL_PREFIX}_data[] = {\n"
	"${data}"
	"}\;\n"
	"const size_t ${SYMBOL_PREFIX}_size = sizeof(${SYMBOL_PREFIX}_data)\;\n"
)

file(WRITE "${DST}.tmp" ${out})
execute_process(COMMAND ${CMAKE_COMMAND} -E rename "${DST}.tmp" "${DST}")
