/*
 * Copyright (c) 2022 Josef 'Jeff' Sipek <jeffpc@josefsipek.net>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#ifndef __SIG_H
#define __SIG_H

#include <jeffpc/types.h>
#include <jeffpc/val.h>

struct sig_pota_ref {
	struct str *ref;
	struct str *name;
	struct str *locs;
	double lat;
	double lon;
	bool active;
	bool have_latlon;
	uint16_t dxcc;
};

struct sig_sota_ref {
	struct str *ref;
	struct str *name;
	uint8_t points;
};

/* load file (CSV) from disk */
extern int sig_load_pota(int dirfd, const char *fname);
extern int sig_load_sota(int dirfd, const char *fname);

/* lookup */
extern int sig_lookup_pota(const char *ref, struct sig_pota_ref *data);
extern int sig_lookup_sota(const char *ref, struct sig_sota_ref *data);

#endif
