/*
 * Copyright (c) 2021-2022 Josef 'Jeff' Sipek <jeffpc@josefsipek.net>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#include "ui.h"

bool ui_dispatch_generic(struct xform *form, int ch)
{
	switch (ch) {
		/* navigate within a field */
		case KEY_HOME:
			xform_driver(form, XFORM_REQ_BEG_FIELD);
			return true;
		case KEY_END:
			xform_driver(form, XFORM_REQ_END_FIELD);
			return true;
		case KEY_LEFT:
			xform_driver(form, XFORM_REQ_PREV_CHAR);
			return true;
		case KEY_RIGHT:
			xform_driver(form, XFORM_REQ_NEXT_CHAR);
			return true;

		/* navigate between fields */
		case '\t':
			/*
			 * Jump to the beginning of this field before going
			 * to the next field.
			 */
			xform_driver(form, XFORM_REQ_BEG_FIELD);
			xform_driver(form, XFORM_REQ_NEXT_FIELD);
			return true;

	}

	return false;
}
