/*
 * Copyright (c) 2021-2023 Josef 'Jeff' Sipek <jeffpc@josefsipek.net>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#ifndef __RPC_RIG_MODE_H
#define __RPC_RIG_MODE_H

enum hrig_mode {
	HRIG_MODE_UNKNOWN = 0,
	HRIG_MODE_AM,
	HRIG_MODE_C4FM,
	HRIG_MODE_FM,
	HRIG_MODE_FM_DATA,
	HRIG_MODE_LSB,
	HRIG_MODE_LSB_CW,
	HRIG_MODE_LSB_DATA,
	HRIG_MODE_LSB_RTTY,
	HRIG_MODE_USB,
	HRIG_MODE_USB_CW,
	HRIG_MODE_USB_DATA,
	HRIG_MODE_USB_RTTY,
};

/* mode name usable for logging */
extern const char *hamlib_mode_name(enum hrig_mode mode);
/* string-ified version of the enum */
extern const char *hamlib_mode_name_raw(enum hrig_mode mode);

#endif
